import { Configuration } from "./configuration";
import { ExecutionMetrics } from "./execution-metrics";
export declare class ExecutionDisplay {
    private configuration;
    private static initProcessors(configuration);
    private static hasCustomDisplaySpecStarted(processors);
    private indent;
    private currentIndent;
    private suiteHierarchy;
    private suiteHierarchyDisplayed;
    private successfulSpecs;
    private failedSpecs;
    private pendingSpecs;
    private lastWasNewLine;
    private hasCustomDisplaySpecStarted;
    private displayProcessors;
    constructor(configuration: Configuration);
    jasmineStarted(runner: any): void;
    summary(metrics: ExecutionMetrics): void;
    specStarted(spec: any): void;
    successful(spec: any): void;
    failed(spec: any): void;
    pending(spec: any): void;
    suiteStarted(suite: any): void;
    suiteDone(): void;
    private successesSummary();
    private successfulSummary(spec, index);
    private failuresSummary();
    private failedSummary(spec, index);
    private pendingsSummary();
    private pendingSummary(spec, index);
    private ensureSuiteDisplayed();
    private displaySuite(suite);
    private process(object, processFunction);
    private computeSuiteIndent();
    private log(stuff);
    private newLine();
    private resetIndent();
    private increaseIndent();
    private decreaseIndent();
}
